
Pbus : FilterPattern {
	var <>numChannels, <>rate, <>fadeTime;
	
	*new { arg pattern, numChannels=2, rate=\audio, fadeTime=0.2;
		^super.new(pattern).numChannels_(numChannels).rate_(rate).fadeTime_(fadeTime)
	}
	embedInStream { arg inevent;
		var server = inevent[\server] ?? { Server.default };
		var groupID, linkID, bus;
		var patterns, event, event2, release;
		
		if(inevent.isNil) { ^nil };
		
		groupID = server.nextNodeID;
		linkID = server.nextNodeID;
		
		if(rate == \audio) {
			bus = server.audioBusAllocator.alloc(numChannels);
			release = {server.audioBusAllocator.free(bus) };
		} {
			bus = server.controlBusAllocator.alloc(numChannels);
			release = {server.controlBusAllocator.free(bus) };
		};
		CmdPeriod.doOnce({release.value; release = nil });
	
		event = inevent.copy;
		event[\addAction] = 1;
		event[\type] = \group;
		event[\delta] = 0;
		event[\id] = groupID;
		
		event2 = inevent.copy;
		
		event2[\type] = \on;
		event2[\group] = groupID;
		event2[\addAction] = 3;
		event2[\delta] = 0;
		event2[\id] = linkID;
		event2[\instrument] = format("system_link_%_%", rate, numChannels);
		event2[\in] = bus;
		event2[\msgFunc] = #{ |out, in, fadeTime, gate=1|
			[\out, out, \in, in, \fadeTime, fadeTime, \gate, gate] 
		};
		event2.postln;
		
		server.makeSafeBundle(nil, { 
			inevent = event.yield; 
			inevent = event2.yield; 
		});
		
		// now embed the pattern
		
		inevent = Pchain(pattern, (group: groupID, out: bus)).embedInStream(inevent);
		
		// finishing
		
		event = if(inevent.notNil) {inevent.copy } {event.copy };
		event[\type] = \kill;
		event[\delta] = 0;
		event[\id] = groupID;
		event[\lag] = fadeTime; // delay freeing to avoid click, does not always work.
		
		event2 = if(inevent.notNil) {inevent.copy } {event.copy };
		event2[\type] = \off;
		event2[\id] = linkID;
		event[\delta] = 0;
		event2[\fadeTime] = fadeTime;
				
		server.makeSafeBundle(server.latency, { 
			release.value; release = nil;
			inevent = event2.yield;
			inevent = event.yield; 
		});
		
		
		^inevent
	}
	
}



